<div x-data>
    <script src="https://js.stripe.com/v3/"></script>
    <script>
        var stripe = Stripe('{{ config('services.stripe.publishable_key') }}');
        // Create an instance of Elements.
        var elements = stripe.elements();
        var clientSecret = null;
    </script>

    <div id="order-wrapper">
        <section class="border-b border-gray-200">
            <div class="max-w-4xl mx-auto">
                @if($stage===3)
                    <div class="result-message -mt-6">
                        <h1 class="text-2xl p-4">Congratulations</h1>
                        <div class="bg-green-100 border-t border-b border-green-500 text-green-700 px-4 py-3"
                             role="alert">
                            <p class="font-bold">Your payment has been confirmed. Thank you.</p>
                            <p class="text-sm">You will receive an email shortly confirming your order and someone from
                                our team will be in touch shortly. If you need us in the meantime, please contact us
                                via <a href="mailto:sales@acereg.com">sales@acereg.com</a> or call 02890 992777.</p>
                        </div>
                        <div class="flex items-center justify-end my-12">
                            <a href="/"
                               class="bg-green-600 hover:bg-green-900 text-gray-200 font-semibold px-4 py-2 cursor-pointer">Next</a>
                        </div>
                    </div>
                @endif

                @if($stage===1)
                    <h2 class="text-center text-4xl font-semibold mb-2">Your Cart</h2>
                @elseif($stage===2)
                    <h2 class="text-center text-4xl font-semibold mb-2">Your Order</h2>
                        <div class="flex justify-center">
                            <img src="/images/PoweredbyStripe-black.svg" style="height: 45px">
                        </div>
                    <br>
                    <p class="text-center"></p>
                    <p class="text-sm">Thank you for choosing to place your order with us. Please provide  your
                        card and address details below. Your card transaction goes securely through the Stripe payment system and for your added protection, we are Members of the Institute of Registration Agents and Dealers.<br><br></p>
                @endif
            </div>
        </section>
        @if ($stage !== 3)
            @if($cartItems && count($cartItems))
                <table class="table-auto w-full">
                    <thead>
                    <tr class="border-b border-gray-200">
                        <th class="px-2 py-4 text-left font-semibold text-sm w-2/3">Registration</th>
                        <th class="px-2 py-4 text-left font-semibold text-sm text-right">All Inclusive</th>
                    </tr>
                    </thead>
                    <tbody>

                    @foreach($cartItems as $key=>$cartItem)
                        <tr class="border-b border-gray-200">
                            <td class="text-sm px-2 py-4">
                                <div class="flex flex-row items-center">
                                    <div class="px-2">
                                        <span class="font-semibold">{{ $cartItem["registration"] }}</span>
                                        @if ($stage === 1)
                                            <br>
                                            <button type="button" class="mt-1 block text-sm text-gray-700"
                                                    wire:click="removeItem('{{$cartItem['id']}}')">Remove
                                            </button>
                                        @else
                                            <div class="mb-2">
{{--
                                                <div class="mb-4">
                                                    <label class="mb-1 text-xs text-gray-700">Registered Keeper</label>
                                                    <input type="text" placeholder="Name of Registered Keeper"
                                                           name="registered_keeper[{{$cartItem['id']}}]"
                                                           class="bg-white rounded-md border border-gray-200 p-2 text-gray-800 w-full"
                                                           wire:model.lazy="registered_keeper.{{$cartItem['id']}}">
                                                </div>
--}}
                                                <div class="mb-4">
                                                    <label class="mb-1 text-xs text-gray-700">How do you want the registration issued ?</label>
                                                    <select name="issue_type[{{$cartItem['id']}}]"
                                                           class="bg-white rounded-md border border-gray-200 p-2 text-gray-800 w-full"
                                                           wire:model.lazy="issue_type.{{$cartItem['id']}}">
                                                        <option>Transfer To Vehicle</option>
                                                        <option>Transfer To Certificate</option>
                                                        <option>Unsure - I will email sales@acereg.com shortly</option>
                                                    </select>
                                                </div>
                                                <div class="mb-4">
                                                    <label class="mb-1 text-xs text-gray-700">Get a set of standard front and rear plates with your order today to save time and money? </label>
                                                    <select name="issue_type[{{$cartItem['id']}}]"
                                                            class="bg-white rounded-md border border-gray-200 p-2 text-gray-800 w-full"
                                                            wire:model.lazy="include_plates.{{$cartItem['id']}}">
                                                        <option value="0">No I will organise them myself</option>
                                                        <option value="1">Yes please. (&pound;{{(float)env("PLATE_PRICE")*((100+env("VATRATE"))/100) }} all inc)</option>
                                                    </select>
                                                </div>

{{--
                                                <div class="mb-4">
                                                    <label class="mb-1 text-xs text-gray-700">What is the current vehicle registration (if applicable)</label>
                                                    <input type="text" placeholder="Current Registration"
                                                           name="current_reg[{{$cartItem['id']}}]"
                                                           class="bg-white rounded-md border border-gray-200 p-2 text-gray-800 w-full"
                                                           wire:model.lazy="current_reg.{{$cartItem['id']}}">
                                                </div>
--}}

                                            </div>
                                        @endif
                                    </div>
                                </div>
                            </td>
                            <td class="text-sm px-2 py-4 text-right">
                                &pound; {{ number_format($cartItem["total"],2) }}</td>
                        </tr>
                    @endforeach
                    @if(count($cartItems)>1)
                        <tr>
                            <td class="text-sm px-2 py-4 font-semibold">Total</td>
                            <td class="text-sm px-2 py-4 text-right">&pound; {{ number_format($grandTotal,2) }}</td>
                        </tr>
                    @endif

                    </tbody>
                </table>
            @else
                <p>Your cart is now empty</p>
            @endif

            @if($stage === 1)
                <div class="flex items-center justify-end my-12">
                    <a href="/" class="mr-2">
                        <div
                            class="bg-yellow-300 hover:bg-yellow-500 text-gray-700 font-semibold px-4 py-2 cursor-pointer">
                            Search For More
                        </div>
                    </a>
                    @if($cartItems && count($cartItems)>0)
                        <div
                            class="bg-green-600 hover:bg-green-900 text-gray-200 font-semibold px-4 py-2 cursor-pointer"
                            wire:click="orderDetails()">Continue to Checkout
                        </div>
                    @endif
                </div>
            @endif

            @if($stage === 2)
                <script>
                    
                    window.addEventListener('getClientSecretAgain', event => {
                       refreshClientSecret();
                    });
                    function refreshClientSecret(){
                        fetch("/create-intent", {
                            method: "GET",
                            headers: {
                                "Content-Type": "application/json"
                            }
                        })
                        .then(function (result) {
                            return result.json();
                        })
                        .then(function (data) {
                            var elements = stripe.elements();
                            clientSecret = data.clientSecret;
                        })
                    }
                    fetch("/create-first-intent", {
                        method: "GET",
                        headers: {
                            "Content-Type": "application/json"
                        }
                    })
                        .then(function (result) {
                            return result.json();
                        })
                        .then(function (data) {
                            var elements = stripe.elements();
                            clientSecret = data.clientSecret;
                            var style = {
                                base: {
                                    color: "#32325d",
                                    fontFamily: 'Arial, sans-serif',
                                    fontSmoothing: "antialiased",
                                    fontSize: "16px",
                                    "::placeholder": {
                                        color: "#32325d"
                                    }
                                },
                                invalid: {
                                    fontFamily: 'Arial, sans-serif',
                                    color: "#fa755a",
                                    iconColor: "#fa755a"
                                }
                            };
                            @this.set('billing_postcode', ""); // empty the postcode because the card postcode is empty too  // hidePostalCode : true
                            
                            var card = elements.create("card", {style: style});
                            // Stripe injects an iframe into the DOM
                            card.mount("#card-element");
                            
                            card.on('blur', function(event) {
                                if(document.querySelector("#billing_postcode").value != '' && document.querySelector("#billing_postcode").value.length < 2){
                                    document.querySelector("#billing_postcode_error").textContent = 'The postcode field is incomplete.';
                                    //document.querySelector("#toggleB").setAttribute("disabled", "");
                                }
                                if(document.querySelector("#billing_postcode").value == ''){
                                    document.querySelector("#billing_postcode_error").textContent = 'The postcode field is required.';
                                    //document.querySelector("#toggleB").setAttribute("disabled", "");
                                }
                                if(document.querySelector("#billing_postcode").value != '' && document.querySelector("#billing_postcode").value.length > 2){
                                    //document.querySelector("#toggleB").removeAttr("disabled");
                                }
                                
                            });

                            card.on("change", function (event) {
                                
                                if (event.value && event.value.postalCode == ''){
                                    document.querySelector("#billing_postcode").value = '';
                                }
                                
                                if (event.value && event.value.postalCode){
                                    @this.set('billing_postcode', event.value.postalCode.toUpperCase());
                                }
                                 
                                // Disable the Pay button if there are no card details in the Element
                                document.querySelector("#pay-now").disabled = event.empty;
                                document.querySelector("#card-error-detail").textContent = event.error ? event.error.message : "";
                                if (document.querySelector("#card-error-detail").textContent) {
                                    document.querySelector("#card-error").classList.remove("hidden");
                                }
                            });

                            var form = document.getElementById("payment-form");
                            document.addEventListener("generate-stripe-token", function (event) {
                                event.preventDefault();
                                  var clientSecretID=null;
                                    fetch("/create-intent", {
                                    method: "GET",
                                    headers: {
                                        "Content-Type": "application/json"
                                        }
                                    })
                                    .then(function (result) {
                                      return result.json();
                                    })
                                    .then(function (data) {
                                        var elements = stripe.elements();
                                        clientSecretID = data.clientSecret;
                                        payWithCard(stripe, card, clientSecretID);
                                    })
                                
                        
                                  
                            });
                        });

                    // Calls stripe.confirmCardPayment
                    // If the card requires authentication Stripe shows a pop-up modal to
                    // prompt the user to enter authentication details without leaving your page.
                    var payWithCard = function (stripe, card, clientSecretID) {

                      
                        loading(true);
                        stripe
                            .confirmCardPayment(clientSecretID, {
                                payment_method: {
                                    card: card
                                }
                            })
                            .then(function (result) {
                                console.log(result);
                                if (result.error) {
                                    // Show error to your customer
                                    showError(result.error.message);
                                } else {
                                    // The payment succeeded!
                                    orderComplete(result.paymentIntent.id);
                                }
                            });
                    };

                    function delete_cookie(name) {
                        document.cookie = name + "=" +
                            ";expires=Thu, 01 Jan 1970 00:00:01 GMT";
                    }

                    /* ------- UI helpers ------- */

                    // Shows a success message when the payment is complete
                    var orderComplete = function (paymentIntentId) {
                        console.log(paymentIntentId);
                        notifyBackEnd(paymentIntentId);
                        window.scrollTo(0, 0);
                    };

                    // Show the customer the error from Stripe if their card fails to charge
                    let showError = function (errorMsgText) {
                        loading(false);
                        var errorMsg = document.querySelector("#card-error-detail");
                        document.querySelector("#card-error").classList.remove("hidden");
                        errorMsg.textContent = errorMsgText;
                        setTimeout(function () {
                            document.querySelector("#card-error").classList.add("hidden");
                            errorMsg.textContent = "";
                        }, 12000);
                    };

                    // Show a spinner on payment submission
                    let loading = function (isLoading) {
                        if (isLoading) {
                            // Disable the button and show a spinner
                            document.querySelector(".button-control").classList.add("hidden");
                            document.querySelector("#spinner").classList.remove("hidden");
                        } else {
                            document.querySelector("#spinner").classList.add("hidden");
                            document.querySelector(".button-control").classList.remove("hidden");
                        }
                    };
                    
                </script>
                <label for="card" class="py-3">
                    Card Details
                </label>

                <div class="shadow-xl bg-blue-50 md:p-3 md:m-3 mb-5 " wire:ignore>
                    <div id="card-element"></div>
                </div>

                <div style="text-align:right;margin-top: -5px;">
                    <small style="color:#ef4444;margin-right: 10px;" id="billing_postcode_error"></small>
                </div>
                
                <div class="flex flex-col py-3">
                    <label for="cardholder" class="mb-1 text-xs text-gray-700">Name</label>
                    <input type="text" id="cardholder" name="cardholder" placeholder="Card Holder Name"
                           class="bg-white rounded-md border border-gray-200 p-2 text-gray-800"
                           wire:model.lazy="cardholder">
                </div>
                <div class="md:flex flex-row ">
                    <div class="md:w-1/2 flex flex-col py-3  md:pr-3">
                        <label for="telephone" class="mb-1 text-xs text-gray-700">Telephone</label>
                        <input type="text" id="telephone" name="telephone" placeholder="Contact Telephone Number"
                               class="bg-white rounded-md border border-gray-200 p-2 text-gray-800"
                               wire:model.lazy="telephone">
                    </div>

                    <div class="md:w-1/2 flex flex-col py-3 md:pl-3">
                        <label for="email" class="mb-1 text-xs text-gray-700">Email</label>
                        <input type="email" id="email" name="email" placeholder="Email Address"
                               class="bg-white rounded-md border border-gray-200 p-2 text-gray-800"
                               wire:model.lazy="email">
                    </div>
                </div>

                <div class="flex flex-col py-3">
                    <label for="billing_address1" class="mb-1 text-xs text-gray-700">Address Line 1</label>
                    <input type="text" id="billing_address1" name="billing_address1" placeholder="First Line Of Address"
                           class="bg-white rounded-md border border-gray-200 p-2 text-gray-800"
                           wire:model.lazy="billing_address1">
                </div>
                <div class="flex flex-col py-3">
                    <label for="billing_address2" class="mb-1 text-xs text-gray-700">Address Line 2</label>
                    <input type="text" id="billing_address2" name="billing_address1"
                           placeholder="Second Line Of Address"
                           class="bg-white rounded-md border border-gray-200 p-2 text-gray-800"
                           wire:model.lazy="billing_address2">
                </div>

                <div class="md:flex flex-row ">
                    <div class="md:w-1/2 flex flex-col py-3  md:pr-3">
                        <label for="billing_city" class="mb-1 text-xs text-gray-700">Town/City</label>
                        <input type="text" id="billing_city" name="billing_city" placeholder="Town or City"
                               class="bg-white rounded-md border border-gray-200 p-2 text-gray-800"
                               wire:model.lazy="billing_city">
                    </div>

                    <div class="md:w-1/2 flex flex-col py-3  md:pl-3">
                        <label for="billing_postcode" class="mb-1 text-xs text-gray-700">Post code (provided via card details above)</label>
                        <input type="text" id="billing_postcode" readonly name="billing_postcode" placeholder="Postcode as per card above"
                               class="bg-gray-300 rounded-md border border-gray-200 p-2 text-gray-800"
                               wire:model.lazy="billing_postcode">
                    </div>
                </div>

                <input type="hidden" name="billing_country" value="GB">

                @if($errors->count())
                    <div role="alert">
                        <div class="bg-red-500 text-white font-bold rounded-t px-4 py-2">
                            There are errors in your form
                        </div>
                        <div class="border border-t-0 border-red-400 rounded-b bg-red-100 px-4 py-3 text-red-700">
                            @foreach ($errors->all() as $error)
                                <div>{{ $error }}</div>
                            @endforeach
                        </div>
                    </div>
                @endif
                <div id="card-error" class="hidden mt-5" role="alert">
                    <div class="bg-red-500 text-white font-bold rounded-t px-4 py-2">
                        There are payment card issues
                    </div>
                    <div class="border border-t-0 border-red-400 rounded-b bg-red-100 px-4 py-3 text-red-700">
                        <div id="card-error-detail"></div>
                    </div>
                </div>
    </div>

    <div class="flex items-center justify-center w-full mb-12 mt-5">

        <label for="toggleB" class="flex items-center cursor-pointer">
            <!-- toggle -->
            <div class="relative">
                <!-- input -->
                <input type="checkbox" id="toggleB" class="sr-only" wire:model="terms">
                <!-- line -->
                <div class="block bg-gray-600 w-14 h-8 rounded-full"></div>
                <!-- dot -->
                <div class="dot absolute left-1 top-1 bg-white w-6 h-6 rounded-full transition"></div>
            </div>
            <!-- label -->
            <div class="ml-3 text-gray-700 font-medium">
                I agree to the <a class="underline" href="/terms-of-service" target="_blank">terms and conditions</a>
            </div>
        </label>
    </div>
    <div class="flex items-center justify-end my-12 button-control">

        @if($terms)
        <div class="bg-yellow-300 hover:bg-yellow-500 text-gray-700 font-semibold px-4 py-2 cursor-pointer mr-2"
             wire:click="backToCart()">&lt;&lt; Back To Cart
        </div>
        <div id="pay-now" class="bg-green-600 hover:bg-green-900 text-gray-200 font-semibold px-4 py-2 cursor-pointer"
             wire:click="placeOrder()">
            <div class="spinner hidden" id="spinner"></div>
            <span id="button-text">Pay now  &gt;&gt;</span>
        </div>
        @endif
    </div>
    <div class="flex justify-center">Need Help ? We have online chat facilities for Facebook and Whats App</div>
    <div class="flex justify-center">
        <a title="Facebook Messenger" href="https://www.messenger.com/t/166799006722353/?ref=aceregsite" target="_blank" class="bg-white px-4 py-2 font-semibold text-blue-700 inline-flex items-center space-x-2">
            <i class="fab fa-facebook-messenger block" style="font-size: 48px"></i>
        </a>
        <a title="WhatsApp Chat" href="https://api.whatsapp.com/send?phone=+447746899094" target="_blank" class="bg-white px-4 py-2 font-semibold text-green-600 inline-flex items-center space-x-2">
            <i class="fab fa-whatsapp block" style="font-size: 48px"></i>
        </a>
    </div>

    @endif
    @endif

</div>

