<div>
    @if($response)
        <div class="bg-teal-100 border-t-4 border-teal-500 rounded-b text-teal-900 px-4 py-3 shadow-md" role="alert">
            <div class="flex">
                <div class="py-1"><svg class="fill-current h-6 w-6 text-teal-500 mr-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><path d="M2.93 17.07A10 10 0 1 1 17.07 2.93 10 10 0 0 1 2.93 17.07zm12.73-1.41A8 8 0 1 0 4.34 4.34a8 8 0 0 0 11.32 11.32zM9 11V9h2v6H9v-4zm0-6h2v2H9V5z"/></svg></div>
                <div>
                    <p class="font-bold">{{ $response }}</p>
                    <p class="text-sm"></p>
                </div>
            </div>
        </div>
    @endif
    <div class="relative w-full mb-3 mt-8">
        <label
            class="block uppercase text-gray-700 text-xs font-bold mb-2"
            for="full-name"
        >Full Name</label
        ><input
            wire:model.lazy="fullName"
            type="text"
            class="border-0 px-3 py-3 placeholder-gray-400 text-gray-700 bg-white rounded text-sm shadow focus:outline-none focus:ring w-full"
            placeholder="Full Name"
            style="transition: all 0.15s ease 0s;"
        />
        @if($errors->first('fullName'))
            <div class="error">{{ $errors->first('fullName') }}</div>
        @endif
    </div>
    <div class="relative w-full mb-3">
        <label
            class="block uppercase text-gray-700 text-xs font-bold mb-2"
            for="email"
        >Email</label
        ><input
            wire:model.lazy="email"
            type="email"
            class="border-0 px-3 py-3 placeholder-gray-400 text-gray-700 bg-white rounded text-sm shadow focus:outline-none focus:ring w-full"
            placeholder="Email"
            style="transition: all 0.15s ease 0s;"
        />
        @if($errors->first('email'))
            <div class="error">{{ $errors->first('email') }}</div>
        @endif
    </div>
    <div class="relative w-full mb-3">
        <label
            class="block uppercase text-gray-700 text-xs font-bold mb-2"
            for="message"
        >Message</label
        ><textarea
            wire:model.lazy="message"
            rows="4"
            cols="80"
            class="border-0 px-3 py-3 placeholder-gray-400 text-gray-700 bg-white rounded text-sm shadow focus:outline-none focus:ring w-full"
            placeholder="Type a message..."
        ></textarea>
        @if($errors->first('message'))
            <div class="error">{{ $errors->first('message') }}</div>
        @endif

    </div>
    <div class="text-center mt-6">
        <button
            class="bg-gray-900 text-white active:bg-gray-700 text-sm font-bold uppercase px-6 py-3 rounded shadow hover:shadow-lg outline-none focus:outline-none mr-1 mb-1"
            type="button"
            style="transition: all 0.15s ease 0s;"
            wire:click="send"
        >
            Send Message
        </button>
    </div>
</div>
